Subject: Re: bug#63480: 30.0.50; [BUG] unimplemented logic regarding read-symbol-shorthands

From: Stefan Kangas <[email-masked]>
Date: Wed, 6 Sep 2023 04:03:58 -0700

João, could you take a look at the below bug?

It seems to be related to the shorthands feature, and your package
breadcrumb.

Ruijie Yu <[email-masked]> writes:

> In GNU Emacs 30.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
>  3.24.37, cairo version 1.17.8) of 2023-05-06 built on ruijie
> Repository revision: f261226d9be4630572df322b2c4f48713c9c2fce
> Repository branch: makepkg
> System Description: Arch Linux
>
>
> Hello,
>
> While trying out João's breadcrumb package, I noticed a few issues
> regarding `read-symbol-shorthands'.  Searching this variable on debbugs
> yields zero results, so I figured maybe I should at least let the
> bugtracker know about them.
>
> First, docstrings do not resolve shorthands at the moment.  [Not the
> main point of this thread.  If we are interested in changing that
> behavior, we can discuss it in a new thread.]
>
> Second, autoload generation, at least the portion responsible for
> `package-vc-install', does not seem to translate the shorthands.
>
> What I did:
>
>     ;; ~15-days-old master
>     $ emacs -Q -nw
>
>     M-x load-lib package-vc RET
>
>     M-: (package-vc-install '(breadcrumb
>         :url "https://github.com/joaotavora/breadcrumb"
>         :rev "e508856a59d18a0d006e215497b5190b3b517791")) RET
>
>     M-x find-lib breadcrumb-autoloads.el RET
>
> Note these portions in breadcrumb.el:
>
> ;;;###autoload
> (defun bc-imenu-crumbs ()
>   "Describe point inside the Imenu tree of current file."
>   ...)
>
> ...
>
> ;; Local Variables:
> ;; read-symbol-shorthands: (("bc-" . "breadcrumb-"))
> ;; End:
>
>
> What I noticed from the generated autoloads file,
> breadcrumb-autoloads.el:
>
> ;;; Generated autoloads from breadcrumb.el
>
> (autoload 'bc-imenu-crumbs "breadcrumb" "\
> Describe point inside the Imenu tree of current file.")
> ...
>
> The first argument to `autoload' here should probably be translated to
> the full name `breadcrumb-imenu-crumbs', and likewise elsewhere.